<template>
  <div>
    <el-form :rules="rules" :model="formData" label-width="120px">
      <el-form-item label="目前密碼" prop="currentPassword">
        <el-input
          ref="password"
          v-model="formData.currentPassword"
          :type="currentPasswordType"
          style="max-width:300px;"
        />
        <span @click="showPwd('currentPassword')">
          <svg-icon :icon-class="currentPasswordType === 'password' ? 'eye' : 'eye-open'" />
        </span>
      </el-form-item>
      <el-form-item label="新密碼" prop="newPassword">
        <el-input
          ref="newPassword"
          v-model="formData.newPassword"
          :type="newPasswordType"
          style="max-width:300px;"
        />
        <span @click="showPwd('newPassword')">
          <svg-icon :icon-class="newPasswordType === 'password' ? 'eye' : 'eye-open'" />
        </span>
      </el-form-item>
      <el-form-item label="再次輸入新密碼" prop="reNewPassword">
        <el-input
          ref="reNewPasword"
          v-model="formData.reNewPassword"
          :type="reNewPasswordType"
          style="max-width:300px;"
        />
        <span @click="showPwd('reNewPassword')">
          <svg-icon :icon-class="reNewPasswordType === 'password' ? 'eye' : 'eye-open'" />
        </span>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="updateAction">確定</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>
<script>
import { form } from './entity'
import { rules } from './rules'
import { update } from './action'

export default {
  data() {
    return {
      formData: form(),
      currentPasswordType: 'password',
      newPasswordType: 'password',
      reNewPasswordType: 'password',
      rules: rules()
    }
  },
  methods: {
    showPwd(inp) {
      if (inp === 'currentPassword') {
        if (this.currentPasswordType === 'password') {
          this.currentPasswordType = ''
        } else {
          this.currentPasswordType = 'password'
        }
      }
      if (inp === 'newPassword') {
        if (this.newPasswordType === 'password') {
          this.newPasswordType = ''
        } else {
          this.newPasswordType = 'password'
        }
      }
      if (inp === 'reNewPassword') {
        if (this.reNewPasswordType === 'password') {
          this.reNewPasswordType = ''
        } else {
          this.reNewPasswordType = 'password'
        }
      }
    },
    updateAction: function() {
      if (this.formData.newPassword !== this.formData.reNewPassword) {
        alert('密碼不一致!')
        return
      }

      update({
        currentPassword: this.formData.currentPassword,
        newPassword: this.formData.newPassword
      })
    }
  }
}
</script>
